class TSesManager {
    private common CSesList ;# is an array of objects

    private variable CFilM    ;# the file system manager
    private variable CMudM
    private variable CActSes

    constructor {aFileSystemManager aMudManager args} {
	set CFilM $aFileSystemManager
	set CMudM $aMudManager
	set CActSes ""

	# laod the session informations from files
	foreach sf [$CFilM getAllSesDataFiles] {
	    set ses [TSession ::\#auto $CFilM $sf]
	    set CSesList([$ses name]) $ses
	}
    }
    method sessionStarted {} { if {[string compare "" $CActSes]} { return 1 } else { return 0 } }
    method getSesNames {} { return [lsort [array names CSesList]] }
    method getMudNames {} { return [$CMudM getMudNames] }
    method getSes {aName} { return $CSesList($aName) } 
    method getSesId {aName} { return [$CSesList($aName) id]} 
    method exists {aName} { return [info exists CSesList($aName)] } 

    method add {aName aPlayer aPassword aMudName} {
	if {[exists $aName]} {
	    ::delete object $CSesList($aName)
	    unset CSesList($aName)	
	} 
	set id [getNewId]
	set CSesList($aName) [TSession ::\#auto $CFilM $aName $aPlayer $aPassword $aMudName $id]
    }
    method rem {aName} {
	if {[exists $aName]} {
	    $CSesList($aName) wipeout
	    ::delete object $CSesList($aName)
	    unset CSesList($aName)	
	}
    }
    method newActSes {aName} { set CActSes [getSes $aName] }
    method connectActSes {aMainWin aCon} { 
	$CActSes connect $CMudM $aMainWin $aCon
    }
    method sesDisconnected {} {
	# this will set CActSes etc,..
	# must be called from outside: main window
	set CActSes ""
    }
    method stopSession {} {
	if {[sessionStarted]} {
	    $CActSes disconnect
	}
    }
    method getSesIds {} { 
	set idlist [list]
	foreach name [getSesNames] {
	    lappend idlist [[getSes $name] id]
	}
	return $idlist
    }
    method getActSes {} { return $CActSes }
    method getActMudName {} { 
	if {[sessionStarted]} { 
	    return [$CActSes mudName]
	} else {
	    return ""
	}
    }
    method getActMud {} {
	return [$CMudM getMud [getActMudName]]
    }
    method getNewId {} {
	set id 0
	set idlist [getSesIds]
	while {[lsearch -exact $idlist $id]!= -1} {
	    incr id
	}
	return $id
    }

}
###################################################################################
class TSesManagerUif {
    inherit iwidgets::Shell

    variable CWid
    variable CWinWid
    variable CParent

    variable CSesM

    constructor {aParent aSesM args} {
	global TV
	set CSesM $aSesM

	configure -title "Session Manager"
	configure -modality application

	set CWid [$this childsite]
	regsub -- {^::} $this    {} CWinWid
	regsub -- {^::} $aParent {} CParent

	#########################################################################
	# create buttons
 	itk_component add   butframem {frame $CWid.butframe -relief ridge -bd 2 } {keep -background}
 	pack $itk_component(butframem) -side bottom -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0
 	itk_component add   butframe  {frame $itk_component(butframem).butframe -relief ridge -bd 0 } {keep -background}
 	pack $itk_component(butframe) -side bottom -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0
 	itk_component add   butframe2 {frame $itk_component(butframem).butframe2 -relief ridge -bd 0 } {keep -background}
 	pack $itk_component(butframe2) -side bottom -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0

 	itk_component add   ok {
 	    button $itk_component(butframe).ok -width 10 -text "save" -command "[code $this save]" -fg black
 	} {keep -background}
 	itk_component add   rem {
 	    button $itk_component(butframe).rem -width 10 -text "remove" -command "[code $this remove]" -fg black
 	} {keep -background}
 	itk_component add   canc {
 	    button $itk_component(butframe).canc -width 10 -text "close" -command "[code $this canc]" -fg black
 	} {keep -background}
 	pack $itk_component(ok) $itk_component(rem) $itk_component(canc) \
 	    -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left

 	itk_component add   start {
 	    button $itk_component(butframe2).start -width 10 -text "load" -command "[code $this startSes]" -fg black
 	} {keep -background}
 	itk_component add   connect {
 	    button $itk_component(butframe2).conn -width 10 -text "connect" -command "[code $this connect]" -fg black
 	} {keep -background}
 	itk_component add   stop {
 	    button $itk_component(butframe2).stop -width 10 -text "stop" -command "[code $this stop]" -fg black
 	} {keep -background}
 	pack $itk_component(stop) $itk_component(start) $itk_component(connect) \
 	    -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0 -side left
	addFGCom [code $itk_component(ok) configure -fg %c] 
	addFGCom [code $itk_component(rem) configure -fg %c] 
	addFGCom [code $itk_component(canc) configure -fg %c] 
	addFGCom [code $itk_component(start) configure -fg %c] 
	addFGCom [code $itk_component(connect) configure -fg %c] 
	addFGCom [code $itk_component(stop) configure -fg %c] 

	#########################################################################
	# ses interface
 	itk_component add   mframe {frame $CWid.mframe -relief ridge -bd 2 } {keep -background}
 	pack $itk_component(mframe) -side top -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0

	######### name
	itk_component add   name {iwidgets::entryfield $itk_component(mframe).name -labeltext "name: " \
				      -width 20 -labelmargin 0 -textvariable TV($this,name) -foreground black
	} {keep -background}
	itk_component add   player {iwidgets::entryfield $itk_component(mframe).player -labeltext "player: " \
				      -width 20 -labelmargin 0 -textvariable TV($this,player) -foreground black
	} {keep -background}
	itk_component add   password {iwidgets::entryfield $itk_component(mframe).password -labeltext "password: " \
				      -width 20 -labelmargin 0 -textvariable TV($this,password) -foreground black
	} {keep -background}
	itk_component add   mudname {
	    iwidgets::combobox $itk_component(mframe).mn \
		-popupcursor hand1 -listheight 100  \
		-labeltext "mud: " -editable 0 \
		-textvariable TV($this,mudname) -foreground black
	} {keep -background}

	pack $itk_component(name) $itk_component(player) $itk_component(password) $itk_component(mudname) \
	    -side top -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0
	addFGCom [code $itk_component(name) configure -foreground %c] 
	addFGCom [code $itk_component(player) configure -foreground %c] 
	addFGCom [code $itk_component(password) configure -foreground %c] 
	addFGCom [code $itk_component(mudname) configure -foreground %c] 


	#########################################################################
	# Sessions selector
 	itk_component add   msframe {frame $CWid.msframe -relief ridge -bd 2 } {keep -background}
 	pack $itk_component(msframe) -side top -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0

	itk_component add   sesselector {
	    iwidgets::scrolledlistbox $itk_component(msframe).ms \
		-labeltext "Sessions: \n\n\n\n\n\n\n\n\n\n" -labelpos w \
		-selectioncommand "[code $this selected]" -height 1  -foreground black
	} {keep -background}
 	pack $itk_component(sesselector) -side top -fill both -expand true -ipadx 0 -ipady 0 -padx 0 -pady 0
	addFGCom [code $itk_component(sesselector) configure -foreground %c] 

	##########################################################################
	# align all that stuff
	iwidgets::Labeledwidget::alignlabels \
	    $itk_component(sesselector) $itk_component(name) $itk_component(player) \
	    $itk_component(password) $itk_component(mudname)

	updateMudUif
	updateUifList
	clearUif
	eval itk_initialize $args	
    }
    method configureButtons {} {
	if {[$CSesM sessionStarted]} {
	    $itk_component(ok)      configure -state disabled
	    $itk_component(rem)     configure -state disabled
	    $itk_component(start)   configure -state disabled
	    $itk_component(connect) configure -state disabled
	    $itk_component(stop)    configure -state normal
	} else {
	    $itk_component(ok)      configure -state normal
	    $itk_component(rem)     configure -state normal
	    $itk_component(start)   configure -state normal
	    $itk_component(connect) configure -state normal
	    $itk_component(stop)    configure -state disabled
	}
    }
    method activate {} {
	updateMudUif
	configureButtons

	iwidgets::Shell::activate
    }
    method startSes {} {
	# dont build connction
	newSes 0
    }
    method connect {} {
	# also start connection to mud
	newSes 1
    }    
    method newSes {aCon} {
        global TV
	set sesname $TV($this,name)
	if {[$CSesM exists $sesname]} {
	    $CSesM   newActSes $sesname
	    $CParent newSes
	    $CSesM   connectActSes $CParent $aCon
	    canc
	} else {
	    TInformer $itk_interior.mess  -foreground $itk_option(-foreground)\
		-information \
		"A session '$sesname' does not exist.\
               \nYou may need to save the session\
               \nor just choose one."
	}
    }
    method stop {} {
	$CSesM stopSession
	configureButtons
    }
    method updateUifList {} {
	$itk_component(sesselector) delete 0 end
	foreach mn [$CSesM getSesNames] {
	    $itk_component(sesselector) insert end $mn
	}
    }
    method updateMudUif {} {
        $itk_component(mudname) clear
        foreach mudname [$CSesM getMudNames] {
            $itk_component(mudname) insert list end $mudname
        }
    }
    method save {} {
	global TV
	set name [string trim $TV($this,name)]
	if {![string compare $name ""]} {
	    TInformer $itk_interior.mess  -foreground $itk_option(-foreground)\
		-information "You have to give a 'name' for the session!"
	    return
	}

	if {[exists $name]} {
	    TConfirmer $itk_interior.save -command "[code $this add $name $TV($this,player) $TV($this,password) $TV($this,mudname)]" \
		-question "The session '$name' already exists!\nDo You really want to overide it?" 
	    return
	}
	add $name $TV($this,player) $TV($this,password) $TV($this,mudname)
    }
    method exists {aName} { return [$CSesM exists $aName]}
    method remove {} {
	global TV
	set name [string trim $TV($this,name)]
	if {![exists $name]} {
	    TInformer $itk_interior.mess  -foreground $itk_option(-foreground)\
		-information "A Session with the name '$name' does not exist!"
	    return
	}
	TConfirmer $itk_interior.remove -command "[code $this rem $name]" \
	    -question "Do you really want to remove the session '$name'?\nYou will loose all information." 	
    }
    method add {aName aPlayer aPassword aMudName} {
	$CSesM add $aName $aPlayer $aPassword $aMudName
	updateUifList
    }
    method rem {aName} {
	$CSesM rem $aName
	updateUifList
	clearUif
    }
    method selected {} {
	global TV
	set name [$itk_component(sesselector) getcurselection]
	if {![string compare "" $name]} { return }
	set ses  [$CSesM getSes $name]
	set TV($this,name) $name
	set TV($this,player)   [$ses player]
	set TV($this,password) [$ses password]
	set TV($this,mudname)  [$ses mudName]
    }
    method clearUif {} {global TV; set TV($this,name) "";set TV($this,player) "";set TV($this,password) ""; set TV($this,mudname) ""}
    method launchUif {}   { clearUif ; activate }
    method canc {}        { deactivate }

    ################################################


}

##########################################################################################################################
##########################################################################################################################
##########################################################################################################################
##########################################################################################################################
##########################################################################################################################


# 
# TSession
#
# A Session is on the one hand side a storage for information like: the
#  relevant mud, player name, passwd, etc
# On the other hand side it is responsible for creating the connection and
#  mentaining various other things, which are needed while mudding:
#  parsing of mud text, parsing of user input, logging, etc,....
#
# Rem: One could think of seperating both tasks: session (data) + connection.
#  Just in case it ever gets important,..
#
class TSession {
    inherit TESCParser

    # ###############################################################################
    # constructor and such,..
    #
    private {
	variable CFilM
	variable CName    
	variable CPlayer
	variable CPassword
	variable CMudName
	variable CId 
	# CName: must be unique
	# CId:   must be unique too: this is needed to request files 
	#         and directories for the mud data to be stored
	#        => may never change again! 
    }
    public {
	constructor {args} { TESCParser::constructor } {}

	# .. file system
	method createFileSystem {} 
	method readFile {aFile} 
	method removeFileSystem {} 
	method wipeout {} 

	# .. general accessors
	method show     {} { puts "$CId -- $CName || $CPlayer $CMudName" }
	method name     {} { return $CName }
	method player   {} { return $CPlayer }
	method password {} { return $CPassword }
	method mudName  {} { return $CMudName }
	method id       {} { return $CId }

	method isLoaded {} { return $_sesLoaded }
    }

    # 
    # logging
    #
    private {
	variable CLogFile
	variable CLogging
	variable CLogFID
    }
    public {
	method logfile {aFile}  
	method logfileExists {} 
	method logOn {}  
	method logOff {} 
	method logToggle {} 
	method isLogging {} 
    }



    private {
	variable _sesLoaded
	variable CSocket
	variable CMainWindow
	variable CMudder
	variable CMapManager

	variable _output
	variable CInput
	variable CTicker

	common CNL
	common CCR
	common CRS
	common CNNL
	
	variable CTabM  ;# user tablist manager
	variable _actP     ;# array index: pattern -> value: level
	variable _actList  ;# level ordered list of patterns
	
	variable CCurrentNotParsedLine    ;# -> need for telnet and esc sequences; only the not parsed/printed part
	variable CCurrentAsciiLine        ;# -> need for actions/highlights/etc
	variable CParseMode               ;# t: telnet, l: line, e: esc
	variable CTelnetProtocol        


	variable CButtonArea
    }


    private method getCFile  {}  { return [$CFilM getMainSesConfFile $CId] }

    method getTabs {} { 
	set retval [$CTabM  getTabs]
	foreach tab [$_output getTabs] {
	    lappend retval $tab
	}
	return $retval
    } 
    

    method readMudFromFile {aFileName} 
    method readMud {} 
    method evalSingleLine {aPart args} 
    method evalSingleLineMode_t {aPart} 
    method evalSingleLineMode_l {aPart} 
    method writeMudText {aPart} 
    method writeMessage {aMsg} { $_output fromSMM $aMsg }


    #
    # printing
    #
    method printf {aStr} { if {$_showoutput} {$_output fromSMM $aStr} }
    method perror {aStr} 

    #
    # user interp: smm commands
    #
    private method _smmActionReadjust  {}
    public {
	method smmTab        {subspec args}
	method smmTick       {subspec args}
	method smmLog        {subspec args}
	method smmUserPrint  {string args}
	method smmKeyCom     {sequence command}
	method smmBell       {subspec args}
	method smmFile       {subspec args}
	method smmKillAll    {}

	method smmActionGet        {alias}
	method smmActionSet        {alias level}
	method smmActionUnset      {alias}
	method smmActionExists     {alias}
	method smmActionList       {}
	method smmActionNames      {pattern}
	
	method smmMapZoom    {subspec args}
	method smmMapExists  {subspec args}
	method smmMapSet     {subspec args}
	method smmMapGet     {subspec args}
	method smmMapCreate  {mapname maplevel}
	method smmMapSwitch  {mapname maplevel}
	method smmMapMove    {subspec args}

	method smmVSet       {varname value}
	method smmVUnset     {varname}
	method smmVGet       {varname}
	method smmVList      {}
	method smmVArray     {option arrayname args}

	method smmGUIAddRow             {rowname}
	method smmGUIRemRow             {rowname}
	method smmGUIAddButton          {rowname buttonname text command}
	method smmGUIRemButton          {rowname buttonname}
	method smmGUIAddCheckbutton     {rowname buttonname text command variablename}
	method smmGUIRemCheckbutton     {rowname buttonname}
	method smmGUIAddLabel           {rowname labelname text width}
	method smmGUIRemLabel           {rowname labelname}
	method smmGUISetLabelText       {rowname labelname text}
	method smmGUIAddVarEntry        {rowname varentryname variablename width } 
	method smmGUIRemVarEntry        {rowname varentryname} 
	method smmGUIAddVarLabel        {rowname varlabelname variablename width } 
	method smmGUIRemVarLabel        {rowname varlabelname} 
	method smmGUIAddVarChooser      {rowname varchoosername variablename width } 
	method smmGUIRemVarChooser      {rowname varchoosername} 
	method smmGUIAddVarChooserItem  {rowname varchoosername item} 
	method smmGUIRemVarChooserItem  {rowname varchoosername index}
	
	method smmOption {opt act}
    }
    private {
	variable _parse          1
	variable _showoutput     1
	variable _showerror      1
    }

    #
    # user interp general stuff
    #
    public {
	method connect {aMudM aMainWin aCon} 
	method cutConnection {}
	method disconnect {} 
	method killall {} 

	method toMud {arg} 
	method toSMM {arg} 

    }
    private {
	variable _showInput
	method   _createInterp {} 
	method   _deleteInterp {} 
    }

}

##################################################################################

#
# create/delete user interp
#
body TSession::_createInterp {} {

    # --- create a namespace, which will hold the gui variables
    namespace eval ::smm::ses {}

    # --- create userinterp
    interp create -- smmuser

    # --- set general interp behaviour
    smmuser alias tomud  [code $this toMud]
    smmuser eval {
	proc unknown {args} { 
	    if {[llength $args]>1} {
		::tomud $args 
	    } else {
		::tomud [lindex $args 0]
	    }
	}
    }
    smmuser eval {
	namespace eval ::ses {
	    ::foreach com [::lsort [::info commands]] {
		::eval "::proc $com {args} { ::eval ::unknown $com \$args }"
	    }
	}
    }

    # --- smm commands
    smmuser alias ::smm::option       [code $this smmOption]
    smmuser alias ::smm::tick         [code $this smmTick]
    smmuser alias ::smm::tab          [code $this smmTab]
    smmuser alias ::smm::log          [code $this smmLog]
    smmuser alias ::smm::showme       [code $this smmUserPrint]
    smmuser alias ::smm::keycom       [code $this smmKeyCom]
    smmuser alias ::smm::bell         [code $this smmBell]
    smmuser alias ::smm::file         [code $this smmFile]
    smmuser alias ::smm::killall      [code $this smmKillAll]

    smmuser alias ::smm::action::list       [code $this smmActionList]
    smmuser alias ::smm::action::get        [code $this smmActionGet]
    smmuser alias ::smm::action::set        [code $this smmActionSet]
    smmuser alias ::smm::action::unset      [code $this smmActionUnset]
    smmuser alias ::smm::action::exists     [code $this smmActionExists]
    smmuser alias ::smm::action::names      [code $this smmActionNames]

    smmuser alias ::smm::map::zoom    [code $this smmMapZoom]
    smmuser alias ::smm::map::exists  [code $this smmMapExists]
    smmuser alias ::smm::map::set     [code $this smmMapSet]
    smmuser alias ::smm::map::get     [code $this smmMapGet]
    smmuser alias ::smm::map::create  [code $this smmMapCreate]
    smmuser alias ::smm::map::switch  [code $this smmMapSwitch]
    smmuser alias ::smm::map::move    [code $this smmMapMove]

    smmuser alias ::smm::gui::set         [code $this smmVSet]
    smmuser alias ::smm::gui::unset       [code $this smmVUnset]
    smmuser alias ::smm::gui::get         [code $this smmVGet]
    smmuser alias ::smm::gui::list        [code $this smmVList]
    smmuser alias ::smm::gui::array       [code $this smmVArray]

    smmuser alias ::smm::gui::addrow        [code $this smmGUIAddRow]
    smmuser alias ::smm::gui::remrow        [code $this smmGUIRemRow]
    smmuser alias ::smm::gui::addbutton     [code $this smmGUIAddButton]
    smmuser alias ::smm::gui::rembutton     [code $this smmGUIRemButton]
    smmuser alias ::smm::gui::addcheckbutton     [code $this smmGUIAddCheckbutton]
    smmuser alias ::smm::gui::remcheckbutton     [code $this smmGUIRemCheckbutton]
    smmuser alias ::smm::gui::addlabel      [code $this smmGUIAddLabel]
    smmuser alias ::smm::gui::remlabel      [code $this smmGUIRemLabel]
    smmuser alias ::smm::gui::setlabeltext  [code $this smmGUISetLabelText]
    smmuser alias ::smm::gui::addvarentry   [code $this smmGUIAddVarEntry]
    smmuser alias ::smm::gui::remvarentry   [code $this smmGUIRemVarEntry]
    smmuser alias ::smm::gui::addvarlabel   [code $this smmGUIAddVarLabel]
    smmuser alias ::smm::gui::remvarlabel   [code $this smmGUIRemVarLabel]
    smmuser alias ::smm::gui::addvarchooser      [code $this smmGUIAddVarChooser]
    smmuser alias ::smm::gui::remvarchooser      [code $this smmGUIRemVarChooser]
    smmuser alias ::smm::gui::addvarchooseritem  [code $this smmGUIAddVarChooserItem]
    smmuser alias ::smm::gui::remvarchooseritem  [code $this smmGUIRemVarChooserItem]

    smmuser alias ::smm::text::delete        [code $_output deleteLastLine]
    smmuser alias ::smm::text::deleterange   [code $_output deleteRangeOnLastLine]
    smmuser alias ::smm::text::subst         [code $_output replaceLastLine]
    smmuser alias ::smm::text::substrange    [code $_output replaceOnLastLine]
    smmuser alias ::smm::text::tag           [code $_output tagLastLine]
    smmuser alias ::smm::text::tagrange      [code $_output tagOnLastLine]
    smmuser alias ::smm::text::substtag      [code $_output tagNreplaceLastLine]
    smmuser alias ::smm::text::substtagrange [code $_output tagNreplaceOnLastLine]

}
body TSession::_deleteInterp {} {
    interp delete smmuser
    namespace delete ::smm::ses
}
body TSession::perror {aStr} { 
    if {!$_showerror} { return }
    regsub -- {tSession[0-7]* } $aStr {}                 aStr 
    regsub -- "$_output "       $aStr {}                 aStr 

    regsub -- {smmOption}       $aStr {smm::option}      aStr 
    regsub -- {smmTab}          $aStr {smm::tab}         aStr 
    regsub -- {smmTick}         $aStr {smm::tick}        aStr 
    regsub -- {smmLog}          $aStr {smm::log}         aStr 
    regsub -- {smmUserPrint}    $aStr {smm::showme}      aStr 
    regsub -- {smmKeyCom}       $aStr {smm::keycom}      aStr 
    regsub -- {smmBell}         $aStr {smm::bell}        aStr 
    regsub -- {smmFile}         $aStr {smm::file}        aStr 
    regsub -- {smmKillAll}      $aStr {smm::killall}     aStr 

    regsub -- {smmActionList}         $aStr {smm::action::list}        aStr 
    regsub -- {smmActionGet}          $aStr {smm::action::get}        aStr 
    regsub -- {smmActionSet}          $aStr {smm::action::set}        aStr 
    regsub -- {smmActionUnset}        $aStr {smm::action::unset}      aStr 
    regsub -- {smmActionExists}       $aStr {smm::action::exists}     aStr 
    regsub -- {smmActionNames}        $aStr {smm::action::names}      aStr 

    regsub -- {smmMapZoom}      $aStr {smm::map::zoom}   aStr 
    regsub -- {smmMapExists}    $aStr {smm::map::exists} aStr 
    regsub -- {smmMapSet}       $aStr {smm::map::set}    aStr 
    regsub -- {smmMapGet}       $aStr {smm::map::get}    aStr 
    regsub -- {smmMapCreate}    $aStr {smm::map::create} aStr 
    regsub -- {smmMapSwitch}    $aStr {smm::map::switch} aStr 
    regsub -- {smmMapMove}      $aStr {smm::map::move}   aStr 

    regsub -- {smmVSet}         $aStr {smm::gui::set}        aStr 
    regsub -- {smmVUnset}       $aStr {smm::gui::unset}      aStr 
    regsub -- {smmVGet}         $aStr {smm::gui::get}        aStr 
    regsub -- {smmVList}        $aStr {smm::gui::list}       aStr 
    regsub -- {smmVArray}       $aStr {smm::gui::array}      aStr 
    regsub -- {smmGUIAddVarChooserItem}    $aStr {smm::gui::addvarchooseritem}    aStr 
    regsub -- {smmGUIRemVarChooserItem}    $aStr {smm::gui::remvarchooseritem}    aStr 
    regsub -- {smmGUIAddVarChooser}        $aStr {smm::gui::addvarchooser}        aStr 
    regsub -- {smmGUIRemVarChooser}        $aStr {smm::gui::remvarchooser}        aStr
    regsub -- {smmGUIAddVarLabel}          $aStr {smm::gui::addvarlabel}          aStr 
    regsub -- {smmGUIRemVarLabel}          $aStr {smm::gui::remvarlabel}          aStr 
    regsub -- {smmGUIAddVarEntry}          $aStr {smm::gui::addvarentry}          aStr 
    regsub -- {smmGUIRemVarEntry}          $aStr {smm::gui::remvarentry}          aStr 
    regsub -- {smmGUIAddLabel}             $aStr {smm::gui::addlabel}             aStr 
    regsub -- {smmGUIRemLabel}             $aStr {smm::gui::remlabel}             aStr 
    regsub -- {smmGUISetLabelText}         $aStr {smm::gui::setlabeltext}         aStr 
    regsub -- {smmGUIAddButton}            $aStr {smm::gui::addbutton}            aStr 
    regsub -- {smmGUIRemButton}            $aStr {smm::gui::rembutton}            aStr 
    regsub -- {smmGUIAddCheckbutton}            $aStr {smm::gui::addcheckbutton}            aStr 
    regsub -- {smmGUIRemCheckbutton}            $aStr {smm::gui::remcheckbutton}            aStr 
    regsub -- {smmGUIAddRow}               $aStr {smm::gui::addrow}               aStr 
    regsub -- {smmGUIRemRow}               $aStr {smm::gui::remrow}               aStr 

    regsub -- {tagNreplaceOnLastLine}      $aStr {::smm::text::substtagrange}     aStr 
    regsub -- {tagNreplaceLastLine}        $aStr {::smm::text::substtag}          aStr 
    regsub -- {deleteRangeOnLastLine}      $aStr {::smm::text::deleterange}       aStr 
    regsub -- {deleteLastLine}             $aStr {::smm::text::delete}            aStr 
    regsub -- {replaceOnLastLine}          $aStr {::smm::text::substrange}        aStr 
    regsub -- {replaceLastLine}            $aStr {::smm::text::subst}             aStr 
    regsub -- {tagOnLastLine}              $aStr {::smm::text::tagrange}          aStr 
    regsub -- {tagLastLine}                $aStr {::smm::text::tag}               aStr 

    $_output fromSMM "ERROR: $aStr"
}

#
# Action
#

body TSession::smmActionSet {alias level} {
    if {[catch {set iLevel [expr double($level)]}]} {
	error "wrong level \"$level\""
    }
    set _actP($alias)  $iLevel
    _smmActionReadjust
}
body TSession::_smmActionReadjust {} {
    foreach a [array names _actP] {
	lappend hl($_actP($a)) $a
    }
    set _actList {}
    foreach lev [lsort -real -decreasing [array names hl]] {
	eval lappend _actList $hl($lev)
    }
    puts $_actList
}
body TSession::smmActionUnset {alias} {
    unset _actP($alias)
    _smmActionReadjust
}
body TSession::smmActionNames {pattern} {
    return [array names _actP $pattern]
}
body TSession::smmActionList {} {
    return $_actList
}
body TSession::smmActionGet {alias} {
    if {[info exists _actP($alias)]} {
	return $_actP($alias)
    } else {
	error "no such action: \"$alias\"."
    }
}
body TSession::smmActionExists {alias} {
    return [info exists _actP($alias)]
}

#
# GUI
#
body TSession::smmGUIAddRow {rowname} {
    $CButtonArea addButtonRow $rowname
}
body TSession::smmGUIRemRow {rowname} {
    $CButtonArea remButtonRow $rowname
}
body TSession::smmGUIAddButton {rowname buttonname text command} {
    $CButtonArea addButton $rowname $buttonname $text [code $this toSMM $command]
}
body TSession::smmGUIRemButton {rowname buttonname} {
    $CButtonArea remButton $rowname $buttonname
}
body TSession::smmGUIAddCheckbutton {rowname buttonname text command variablename} {
    $CButtonArea addCheckbutton $rowname $buttonname $text [code $this toSMM $command] $variablename
}
body TSession::smmGUIRemCheckbutton {rowname buttonname} {
    $CButtonArea remCheckbutton $rowname $buttonname
}
body TSession::smmGUIAddLabel {rowname labelname text width} {
    $CButtonArea addLabel $rowname $labelname $text $width
}
body TSession::smmGUIRemLabel {rowname labelname} {
    $CButtonArea remLabel $rowname $labelname
}
body TSession::smmGUISetLabelText {rowname labelname text} {
    $CButtonArea setLabelText $rowname $labelname $text 
}
body TSession::smmGUIAddVarEntry        {rowname varentryname variablename width } {
    $CButtonArea addVarEntry $rowname $varentryname $variablename $width
}
body TSession::smmGUIRemVarEntry        {rowname varentryname} {
    $CButtonArea remVarEntry $rowname $varentryname
} 
body TSession::smmGUIAddVarLabel        {rowname varlabelname variablename width } {
    $CButtonArea addVarLabel $rowname $varlabelname $variablename $width
} 
body TSession::smmGUIRemVarLabel        {rowname varlabelname} {
    $CButtonArea remVarLabel $rowname $varlabelname
} 
body TSession::smmGUIAddVarChooser      {rowname varchoosername variablename width } {
    $CButtonArea addVarChooser $rowname $varchoosername $variablename $width
} 
body TSession::smmGUIRemVarChooser      {rowname varchoosername} {
    $CButtonArea remVarChooser $rowname $varchoosername
} 
body TSession::smmGUIAddVarChooserItem  {rowname varchoosername item} {
    $CButtonArea addVarChooserItem $rowname $varchoosername $item
} 
body TSession::smmGUIRemVarChooserItem  {rowname varchoosername index} {
    $CButtonArea remVarChooserItem $rowname $varchoosername $index
}

#
# GUI-Var-Access
#
body TSession::smmVSet {varname value} {
    namespace eval ::smm::ses "set $varname $value"
}
body TSession::smmVUnset {varname} {
    namespace eval ::smm::ses "unset $varname"
}
body TSession::smmVGet {varname} {
    namespace eval ::smm::ses "return \[set $varname\]"
}
body TSession::smmVList {} {
    set retlist [list]
    set vl [namespace eval ::smm::ses { info vars }]
    foreach varname $vl {
	set fullname [namespace eval ::smm::ses "namespace which -variable [list $varname]"]
	if {[string match {::smm::ses::*} $fullname]} {
	    lappend retlist $varname
	}
    }
    return $retlist
}
body TSession::smmVArray {option arrayname args} {
    namespace eval ::smm::ses "array $option $arrayname $args"
}

#
# Map-Get
#
body TSession::smmMapGet {subspec args} {
    switch -exact -- $subspec {
	"zoomname"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::get zoomname\"." }
	    return [[$CMapManager getZoomPos] getMapName]
	}
	"zoomlevel"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::get zoomlevel\"." }
	    return [[$CMapManager getZoomPos] getMapLevel]
	}
	"zoomx"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::get zoomx\"." }
	    return [[$CMapManager getZoomPos] getX]
	}
	"zoomy"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::get zoomy\"." }
	    return [[$CMapManager getZoomPos] getY]
	}
	"playername"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::get playername\"." }
	    return [[$CMapManager getPlayerPos] getMapName]
	}
	"playerlevel"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::get playerlevel\"." }
	    return [[$CMapManager getPlayerPos] getMapLevel]
	}
	"playerx"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::get playerx\"." }
	    return [[$CMapManager getPlayerPos] getX]
	}
	"playery"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::get playery\"." }
	    return [[$CMapManager getPlayerPos] getY]
	}
	"exitwithcommand" {
	    if {[llength $args]!=5} { error "wrong \# args: should be \"smm::map::get exitwithcommand command map-name map-level x y\"." }
	    return [$CMapManager getExitWithCommand [lindex $args  4] \
			[lindex $args  0] [lindex $args  1] [lindex $args  2] [lindex $args  3]]
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::map::get\": must be zoomname, zoomlevel, zoomx, zoomy, playername, playerlevel, playerx, playery or exitwithcommand." 
	}
    }
}

#
# Map-Set
#
body TSession::smmMapSet {subspec args} {
    switch -exact -- $subspec {
	"zoompos"    { 
	    if {[llength $args]!=4} { error "wrong \# args: should be \"smm::map::set zoompos map-name map-level x y\"." }
	    set mapnamearg  [lindex $args 0]
	    set maplevelarg [lindex $args 1]
	    set posxarg     [lindex $args 2]
	    set posyarg     [lindex $args 3]
	    if {[$CMapManager existsMap $mapnamearg $maplevelarg]} {
		$CMapManager setZoomPos $mapnamearg $maplevelarg $posxarg $posyarg
	    } else {
		error "map '$mapnamearg' (level $maplevelarg) does not exist!"
	    }
	}
	"playerpos" {
	    if {[llength $args]!=4} { error "wrong \# args: should be \"smm::map::set playerpos map-name map-level x y\"." }
	    set mapnamearg  [lindex $args 0]
	    set maplevelarg [lindex $args 1]
	    set posxarg     [lindex $args 2]
	    set posyarg     [lindex $args 3]
	    if {[$CMapManager existsMap $mapnamearg $maplevelarg]} {
		$CMapManager setPlayerPos $mapnamearg $maplevelarg $posxarg $posyarg
	    } else {
		error "map '$mapnamearg' (level $maplevelarg) does not exist!"
	    }
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::map::set\": must be zoompos or playerpos." 
	}
    }
}

#
# Map-Move
#
body TSession::smmMapMove {subspec args} {
    switch -exact -- $subspec {
	"useexit"                {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::map::move $subspec exit-pos\"." }
	    $CMapManager movePlayer useexit [lindex $args  0] 
	}
	"useexitwithcommand"     {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::map::move $subspec command\"." }
	    $CMapManager movePlayer useexitwithcommand [lindex $args  0] 
	}
	"followexit"             {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::map::move $subspec exit-pos\"." }
	    $CMapManager movePlayer followexit [lindex $args  0] 
	}
	"followexitwithcommand"  {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::map::move $subspec command\"." }
	    $CMapManager movePlayer followexitwithcommand [lindex $args  0] 
	}
	"powerwalk" {
	    if {[llength $args]!=4} { error "wrong \# args: should be \"smm::map::move $subspec map-name map-level x y\"." }
	    $CMapManager speedy [lindex $args  0] [lindex $args 1] [lindex $args  2] [lindex $args  3]
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::map::move\": must be useexit, useexitwithcommand, followexit, followexitwithcommand or powerwalk." 
	}
    }
}

#
# Map-Exists
#
body TSession::smmMapExists {subspec args} {
    switch -exact -- $subspec {
	"room"    { 
	    if {[llength $args]!=4} { error "wrong \# args: should be \"smm::map::exists room map-name map-level x y\"." }
	    return [$CMapManager existsRoom [lindex $args  0] [lindex $args 1] [lindex $args  2] [lindex $args  3]]
	}
	"map"    { 
	    if {[llength $args]!=2} { error "wrong \# args: should be \"smm::map::exists map map-name map-level\"." }
	    return [$CMapManager existsMap [lindex $args  0] [lindex $args 1]]
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::map::exists\": must be map or room." 
	}
    }
}

#
# Map-Create
#
body TSession::smmMapCreate {mapname maplevel} {
    $CMapManager createMap $mapname $maplevel
}

#
# killall
#
body TSession::smmKillAll {} {
    killall
}

#
# Map-Switch
#
body TSession::smmMapSwitch {mapname maplevel} {
    $CMapManager changeMap $mapname $maplevel
}

#
# Map-Zoom
#
body TSession::smmMapZoom {subspec args} {
    switch -exact -- $subspec {
	"accept"    { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::zoom accept\"." }
	    $CMapManager acceptRoom 
	}
	"reset"     { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::zoom reset\"." }
	    $CMapManager resetRoom 
	}
	"clear" { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::zoom clear\"." }
	    $CMapManager zifRemoveRoom 
	}
	"setbg"     { 
	    if {[llength $args]!=3} { error "wrong \# args: should be \"smm::map::zoom setbg bg-type bg-category bg-name\"." }
	    $CMapManager zifSetBg [lindex $args 0] [lindex $args 1] [lindex $args 2]
	}
	"setstuff"  { 
	    if {[llength $args]!=4} { error "wrong \# args: should be \"smm::map::zoom setstuff stuff-pos stuff-type stuff-category stuff-name\"." }
	    $CMapManager zifSetStuff [lindex $args 0] [lindex $args 1] [lindex $args 2] [lindex $args 3]
	}
	"remstuff"  { 
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::map::zoom remstuff stuff-pos\"." }
	    $CMapManager zifRemStuff [lindex $args 0]
	}
	"remtext"   { 
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm::map::zoom remtext\"." }
	    $CMapManager zifRemText 
	}
	"settext"   { 
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::map::zoom settext text\"." }
	    $CMapManager zifSetText [lindex $args 0]
	}
	"remexit"   { 
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::map::zoom remexit exit-position\"." }
	    $CMapManager zifRemExit [lindex $args 0]
	}
	"setexit"   { 
	    if {[llength $args]!=13} { error "wrong \# args: should be \"smm::map::zoom setexit position command mapname maplevel connect-x connect-y draw-x draw-y door open-door-command close-door-command line-thickness line-color\"." }
	    $CMapManager zifSetExit \
		[lindex $args  0] [lindex $args 1] [lindex $args  2] [lindex $args  3] \
		[lindex $args  4] [lindex $args 5] [lindex $args  6] [lindex $args  7] \
		[lindex $args  8] [lindex $args 9] [lindex $args 10] [lindex $args 11] \
		[lindex $args 12] 
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::map::zoom\": must be accept, reset, clear, setbg, setstuff, remstuff, remtext, settext, remexit or setexit." 
	}
    }
}

#
# File
#
body TSession::smmFile {subspec args} {
    switch -exact -- $subspec {
	"readasmud" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::file readasmud file\"." }
	    readMudFromFile [lindex $args 0]	    
	}
	"eval" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::file eval file\"." }
	    toSMM "::source [lindex $args 0]"
	}
	"usereval" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::file usereval file\"." }
	    toSMM "::source [$CFilM getScriptFile [lindex $args 0]]"
	}
	"syseval" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::file syseval file\"." }
	    toSMM "::source [$CFilM getSysScriptFile [lindex $args 0]]"
	}
	"send" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm::file send file\"." }
	    if {[string compare "" $CSocket]==0} { error "no connection established." }
	    set filename [lindex $args 0]
	    set fileId [open $filename r]
	    if {[catch {puts $CSocket [read $fileId]}]} {
		TInformer $itk_interior.mess  -foreground $itk_option(-foreground)\
		    -vanishafter 3 -information "Connection to the mud failed!"
	    }
	    close $fileId
	    printf "File sent: $filename"
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::file\": must be readasmud, eval, usereval, syseval or send." 
	}
    }
}

#
# Bell 
#
body TSession::smmBell {subspec args} {
    switch -exact -- $subspec {
	"1" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:bell 1\"." }
	    exec xset b on
	}
	"0" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:bell 0\"." }
	    exec xset b off
	}
	"ring" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:bell ring\"." }
	    bell
	}
	"set" {
	    if {[llength $args]!=3} { error "wrong \# args: should be \"smm:bell set volume herz milliseconds\"." }
	    exec xset b [lindex $args 0] [lindex $args 1] [lindex $args 2] 
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::bell\": must be 1, 0, ring or set." 
	}
    }
}

#
# KeyCom
#
body TSession::smmKeyCom {sequence command} {
    $CInput bindevent $sequence [code $this toSMM $command]
}

#
# showme
#
body TSession::smmUserPrint {string {tags ""}} {
    $_output userPrint $string $tags
}

#
# Logging
#
body TSession::smmLog {subspec args} {
    switch -exact -- $subspec {
	"file" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm:log file filename\"." }
	    logfile [lindex $args 0]
	}
	"1" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:log 1\"." }
	    if {![logfileExists]}   { error "no logfile defined." }
	    logOn
	}
	"0" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:log 0\"." }
	    logOff
	}
	"!" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:log !\"." }
	    if {![logfileExists]}   { error "no logfile defined." }
	    logToggle
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::log\": must be file, 1, 0 or !." 
	}
    }
    if {[isLogging]} {
	printf "SMM: logging turned on!"
    } else {
	printf "SMM: logging turned off!"
    }
}

#
# Option
#
body TSession::smmOption {option action} {
    switch -exact -- $option {
	"parse" {
	    switch -- $action {
		0 { set _parse 0 }
		1 { set _parse 1 }
		! { set _parse [expr !$_parse] }
		? {  }
		default { error "bad action \"$action\" to \"smm::option parse\": must be 0, 1, ! or ?."}
	    }
	    return $_parse
	}
	"output" {
	    switch -- $action {
		0 { set _showoutput 0 }
		1 { set _showoutput 1 }
		! { set _showoutput [expr !$_showoutput] }
		? {  }
		default { error "bad action \"$action\" to \"smm::option output\": must be 0, 1, ! or ?."}
	    }
	    return $_showoutput
	}
	"error" {
	    switch -- $action {
		0 { set _showerror 0 }
		1 { set _showerror 1 }
		! { set _showerror [expr !$_showerror] }
		? {  }
		default { error "bad action \"$action\" to \"smm::option error\": must be 0, 1, ! or ?."}
	    }
	    return $_showerror
	}
	"devmode" {
	    switch -- $action {
		0 { $CMapManager setDevMode 0 }
		1 { $CMapManager setDevMode 1 }
		! { $CMapManager setDevMode [expr ![$CMapManager devMode]] }
		? {  }
		default { error "bad action \"$action\" to \"smm::option devmode\": must be 0, 1, ! or ?."}
	    }
	    return [$CMapManager devMode]
	}
	default { 
	    error "bad option \"$option\" to \"smm::option\": must be parse, devmode, output or error." 
	    return {}
	}
    }
}

#
# Tab
#
body TSession::smmTab {subspec args} {
    switch -exact -- $subspec {
	"add" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm:tab add string\"." }
	    $CTabM add [lindex $args 0]
	}
	"rem" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm:tab rem string\"." }
	    $CTabM rem [lindex $args 0]
	} 
	"list" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:tab list\"." }
	    printf "Tabs: [lsort [$CTabM getAllNames]]"
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::tab\": must be add, rem or list." 
	}
    }
}
#
# Tick
#
body TSession::smmTick {subspec args} {
    switch -exact -- $subspec {
	"on" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:tick on\"." }
	    $CTicker start
	}
	"off" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:tick off\"." }
	    $CTicker stop
	} 
	"reset" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:tick reset\"." }
	    $CTicker reset
	}
	"clear" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:tick clear\"." }
	    $CTicker clear
	}
	"size" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm:tick size size\"." }
	    $CTicker setSize [lindex $args 0]
	}
	"add" {
	    if {[llength $args]!=2} { 
		error "wrong \# args: should be \"smm:tick add second command\"." }
	    $CTicker addTickCommand [lindex $args 0] [lindex $args 1]
	}
	"remove" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm:tick remove second\"." }
	    $CTicker remTickCommand [lindex $args 0]
	}
	"show" {
	    if {[llength $args]!=1} { error "wrong \# args: should be \"smm:tick show second\"." }
	    set sec [lindex $args 0]
	    if {[$CTicker existsCommand $sec]} { 
		set com [$CTicker getCommand $sec]
	    } else {
		set com "No tick command for second \"$sec\"!"
	    }
	    printf "Tick [format {%4d} $sec]: $com"
	}
	"list" {
	    if {[llength $args]!=0} { error "wrong \# args: should be \"smm:tick list\"." }
	    set secl [$CTicker getAllTimes] 
	    if {[llength $secl] == 0} {
		printf "No tick commands defined!"
	    } else {
		foreach sec $secl {
		    printf "Tick [format {%4d} $sec]: [$CTicker getCommand $sec]"
		}
	    }
	}
	default { 
	    error "bad subspec \"$subspec\" to \"smm::tick\": must be on, off, reset, clear, size, add, remove, show or list." 
	}
    }
}


#
# --- user interp
#
body TSession::toMud {arg} {
    if {$_showInput} { $_output fromInput $arg }
    if {[string compare "" $CSocket]!=0} {
	if {[catch {puts $CSocket $arg}]} {
	    TInformer $itk_interior.mess  -foreground $itk_option(-foreground)\
		-vanishafter 3 -information "Connection to the mud failed!"
	}
    }
}
body TSession::toSMM {arg} {
    if {$_parse} {
	if { ![string compare "" [string trim $arg]] } {	
	    toMud $arg    
	} else {
	    if { [catch { smmuser eval "::namespace eval ::ses { $arg }" } errtext] } {
		perror $errtext
	    } else {
		return $errtext
	    }
	}
    } else {
	if {[string compare $arg "::smm::option parse 1"]} {
	    toMud $arg
	} else {
	    if { [catch { smmuser eval "::namespace eval ::ses { $arg }" } errtext] } {
		perror $errtext
	    }
	}
    }
}









# --- logging -----------------------------------------------------
body TSession::logfile {aFile}  {
    if {[logfileExists]} {
	flush $CLogFID
	close $CLogFID
    } 
    set CLogFile $aFile 
    set CLogFID [open $CLogFile {WRONLY CREAT APPEND}]
}
body TSession::logfileExists {} {
    if {[string compare "" $CLogFile]} {
	return 1
    } else {
	return 0
    }
}
body TSession::logOn {} { 
    set CLogging 1 
}
body TSession::logOff {} { 
    set CLogging 0 
    if {[logfileExists]} {
	flush $CLogFID
	close $CLogFID
    } 
}
body TSession::logToggle {} { 
    set CLogging [expr !$CLogging] 
    if {[isLogging]} {
	logOn
    } else {
	logOff
    }
}
body TSession::isLogging {} {return $CLogging}

# --- connect -----------------------------------------------------
body TSession::connect {aMudM aMainWin aCon} {
    set mud [$aMudM getMud $CMudName]
    if {!$_sesLoaded} {
	set CMainWindow $aMainWin
	set CMudder     [$aMainWin getMudderUif]
	set CMapManager [$aMainWin getMapManager]
	$CMapManager assignSession $this
	set _output     [$CMudder getOutput]      
	set CInput      [$CMudder getEntryX]      
	set CButtonArea [$CMudder getButtonArea]

	set CTicker     [$aMainWin getTicker]
	$CTicker bindToSes $this

	set _showInput 1
	set _parse     1

	$CMudder bindToSes $this
    }
    if {$aCon} {
	cutConnection
	set CSocket [socket [$mud host] [$mud port]]
	fconfigure $CSocket -blocking 0 -buffering none -translation {lf lf}
	fileevent  $CSocket readable [code $this readMud]
	$_output fromSMMImportant "Connection opened!"
    } else {
	set CSocket ""
    }
    if {!$_sesLoaded} {
	_createInterp	
	smmFile eval [getCFile]
    }
    set _sesLoaded 1
}

body TSession::cutConnection {} {
    if {[string compare "" $CSocket]!=0} {
	close $CSocket
	set CSocket ""
	$_output fromSMMImportant "Connection closed!"
    }
}
body TSession::disconnect {} {
    cutConnection

    $CMainWindow sesDisconnected
    $CButtonArea clear
    $CInput unbindFromSes
    $CTicker unbindFromSes

    _deleteInterp
    set _sesLoaded 0
}
body TSession::killall {} {
    $CTabM clear
    set _actList {}
    foreach i [array names _actP] { unset _actP($i) }
}

# -------------------------------------------------------------------
body TSession::readMudFromFile {aFileName} {
    if {![file exists $aFileName]} {
	bell
	return
    }
    set fid [open $aFileName "r"]
    set CCurrentNotParsedLine ""
#     set c 0
    while {![eof $fid]} {
	gets $fid line
	evalSingleLine "\n$line" 1

	update idletasks

# 	incr c
# 	if {$c>9} {
# 	    $_output see end
# 	    update idletasks
# 	    set c 0
# 	}
    }

    close $fid
    $_output see end
    update idletasks
}
body TSession::readMud {} {
    set x [read $CSocket]
    if ([string compare "" $x]==0) {
	cutConnection
	#disconnect
	return
    }
    regsub -all -- $CCR $x {} x
    regsub -all -- $CNL $x $CNNL x

    set p $CCurrentNotParsedLine$x
    set CCurrentNotParsedLine ""
#    set c 0
    foreach line [split $p $CRS ] {
	evalSingleLine "$line" 1
	update idletasks
# 	incr c
# 	if {$c>19} {
# 	    $_output see end
# 	    update idletasks
# 	    set c 0
# 	}
    }

    $_output see end
    update idletasks
}

#
# eval single lines
#
body TSession::evalSingleLineMode_t {aPart} {
    # parsed seq's:
    #  \xff\xfb\x01 -> echo input
    #  \xff\xfc\x01 -> dont echo input	    
    switch -exact -- $CTelnetProtocol {
	null {
	    if {[string length $aPart]>0} {
		set nextChar [string index $aPart 0]
		switch -exact -- $nextChar {
		    \xfb {
			#nodebug puts will!
			set CTelnetProtocol will 
		    }
		    \xfc {
			#nodebug puts wont!;
			set CTelnetProtocol wont
		    }
		    default {
			puts "ERROR: telnet parse, unknown protocol, '[charToInt $nextChar]'"
			set CParseMode l
		    }
		}
		evalSingleLine [string range $aPart 1 end]
	    }
	}
	will {
	    if {[string length $aPart]>0} {
		set nextChar [string index $aPart 0]
		switch -exact -- $nextChar {
		    \x01 { 
			$CInput hideInput
			set _showInput 0
		    }
		    default {
			puts "ERROR: telnet parse, unknown will command, '[charToInt $nextChar]'"
		    }
		}
		set CTelnetProtocol null
		set CParseMode l
		evalSingleLine [string range $aPart 1 end]
	    }
	}
	wont {
	    if {[string length $aPart]>0} {
		set nextChar [string index $aPart 0]
		switch -exact -- $nextChar {
		    \x01 { 
			$CInput showInput
			set _showInput 1
		    }
		    default {
			puts "ERROR: telnet parse, unknown wont command, '[charToInt $nextChar]'"
		    }
		}
		set CTelnetProtocol null
		set CParseMode l
		evalSingleLine [string range $aPart 1 end]
	    }
	}
    }
}
body TSession::evalSingleLineMode_l {aPart} {
    if {[regexp -- "(\[^\x1b\xff\]*)(\[\x1b\xff\])(.*)" $aPart dummy b c d]} {
	#b: contains all before the command seq (esc or telnet)
	#c: contains the first command seq char -> may be \x1b or \xff
	#d: contains the rest of the string

	#. first write away the first part
	writeMudText $b			
	if {[string compare "\x1b" $c] == 0} {
	    # esc seq
	    
	    #. check if the complete sequence is in
	    if {[escAnalyse $d]} {
		#nodebug puts "<<$CESCFinal>>$CESCParameters<<"
		switch -exact -- $CESCFinal {
		    m { $_output setColors $CESCParameters }
		    s { $_output rememberCursorPosition }
		    u { $_output returnToCursorPosition }
		    f - H {
			$_output moveCursorTo $CESCParameters
		    }
		    h { 
			# cursor on??
		    }
		    l { 
			# cursor off??
		    }
		    r { $_output setScrollRegion $CESCParameters	}
		    J { 
			switch -- $CESCParameters {
			    ""      { $_output clearToStart }
			    "1"     { $_output clearToEnd }
			    default { $_output clear }
			}
		    }
		    K { 
			switch -- $CESCParameters {
			    "1"     { $_output clearToStartOfLine }
			    default { $_output clearToEndOfLine }
			}
		    }
		    P { $_output delChars $CESCParameters	}
		    L { $_output addLinesBeforeCurPos $CESCParameters	}
		    M { $_output remLinesAfterCurPos $CESCParameters	}
		    A { $_output moveup $CESCParameters	}
		    B { $_output movedown $CESCParameters	}
		    C { $_output moveright $CESCParameters	}
		    D { $_output moveleft $CESCParameters }
		    7 - 8 {
			# ??
		    }
		    default {
			msgError "ESC Error:\nFinal: '$CESCFinal'\nParameter: '$CESCParameters'\nIntermediate: '$CESCIntermediates'\nFollowed by: \[$CESCParsedText\]"
		    }
		}
		evalSingleLine "$CESCParsedText"
	    } else {			    
		set CCurrentNotParsedLine "$c$d"
		if {[string length $CCurrentNotParsedLine]>100} {
		    set CCurrentNotParsedLine [string range $CCurrentNotParsedLine 1 end]
		    msgError "ERROR: seq not complete or not known: ESC+'$d'\n--------------------------------\n'\[$c$d'\]"
		}
	    }


	} else {
	    # telnet seq
	    set CParseMode t
	    evalSingleLineMode_t $d
	}
    } else {
	writeMudText $aPart
    }
}
body TSession::evalSingleLine {aPart args} {
    # first check if a esc for telnet sequence is
    # in the line: \xff (telnet:iac) \x1b (esc) 

    #nodebug puts "|$aPart|"

    evalSingleLineMode_$CParseMode $aPart

    if {[llength $args]>0} {
	foreach act $_actList {
	    set line [$_output getLastLine]
	    if {[toSMM [list $act $line]]} { break }
	}
    }
}
body TSession::writeMudText {aPart} {
    # -----------------------------------------------
    # screen output
    $_output fromMud $aPart
    # file logging
    if {$CLogging} {
	puts -nonewline $CLogFID $aPart
    }
}

# ----------------------------------------------------------------------
body TSession::createFileSystem {} {
    file mkdir    [$CFilM getSesDir    $CId]

    # session information
    set    fid [open [$CFilM getSesDataFile $CId] "w+"]
    puts  $fid 1 ;# file version
    puts  $fid [id]
    puts  $fid [name]
    puts  $fid [player]
    puts  $fid [password]
    puts  $fid [mudName]
    close $fid

    # main session configuration file
    set    fid [open [$CFilM getMainSesConfFile $CId] "CREAT RDWR"]
    close $fid
}
body TSession::readFile {aFile} {
    set    fid [open $aFile "r"]
    gets  $fid version
    gets  $fid CId
    gets  $fid CName
    gets  $fid CPlayer
    gets  $fid CPassword
    gets  $fid CMudName
    close $fid
}
body TSession::removeFileSystem {} { 
    file delete -force -- [$CFilM getSesDir    $CId]
}
body TSession::wipeout {} {
    removeFileSystem
}

# ----------------------------------------------------------------------------
body TSession::constructor {args} {
    set CButtonArea ""
    set CSocket ""
    set _sesLoaded 0
    set CCurrentNotParsedLine ""
    set CCurrentAsciiLine     ""
    set CParseMode            l
    set CTelnetProtocol       null

    set CTicker               ""

    set CLogFile              ""
    set CLogging              0
    set CLogFID               ""
    
    set CNL   "\n"
    set CCR   "\r"
    set CRS   [format "%c" 30]
    set CNNL  "$CRS$CNL"

    # init managers
    set CTabM      [TTabManager  ::\#auto]
    set _actList {}
    switch [llength $args] {
	2 {
	    set CFilM [lindex $args 0]
	    readFile  [lindex $args 1]
	}
	6 {
	    set CFilM     [lindex $args 0]
	    set CName     [lindex $args 1]
	    set CPlayer   [lindex $args 2]
	    set CPassword [lindex $args 3]
	    set CMudName  [lindex $args 4]
	    set CId       [lindex $args 5]
	    createFileSystem
	}
	default {
	    error "Wrong number of arguments to constructor!"
	}
    }
}






