class TTicker {

    variable CTickSize
    variable CTickCounter

    variable CSes
	
    variable CCommandArray
    
    method bindToSes {aSes} {
	set CSes    $aSes
    }
    method unbindFromSes {} {
	set CSes    ""
	stop
	clear
	set CTickSize     75
    }

    method isBoundToSes {} {
	return [string compare "" $CSes]
    }
    method stop {} { 
	global __Ticker
	after cancel [code $this ticking] 
	set CTickCounter  0	
	updateLabel
	set __Ticker($this,indicator) 0
    }
    method start {} { 
	global __Ticker

	if {[isBoundToSes]} {
	    ticking 
	    set __Ticker($this,indicator) 1
	} else {
	    stop
	}
    }
    method reset {} {
	set CTickCounter 0
    }
    method setSize {aSize} {
	set CTickSize    $aSize
	set CTickCounter 0
    }
    method addTickCommand {aSec aCom} {
	set CCommandArray([expr $aSec]) $aCom
    }
    method remTickCommand {aSec} {
	if {[info exists CCommandArray([expr $aSec])]} {
	    unset CCommandArray([expr $aSec])
	}
    }
    method clear {} {
	foreach index [array names CCommandArray] {
	    unset CCommandArray($index)
	}
    }
    method getAllTimes {} { return [lsort -integer [array names CCommandArray]] }
    method getCommand {aSec} {
	if {[info exists CCommandArray([expr $aSec])]} {
	    return "$CCommandArray([expr $aSec])"
	} else {
	    return ""
	}
    }
    method existsCommand {aSec} {
	return [info exists CCommandArray([expr $aSec])]
    }


    method toggle {} {
	global __Ticker
	if {$__Ticker($this,indicator)} {
	    start
	} else {
	    stop
	}
    }

    method getLabelVarName {} { return "__Ticker($this,label)" }
    method getIndicatorVarName {} { return "__Ticker($this,indicator)" }
    method updateLabel {} {
	global __Ticker
	set __Ticker($this,label) "Tick \[[format {%4d} $CTickCounter]/[format {%4d} $CTickSize]\]"
    }
    constructor {} {
	global __Ticker

	set CTickSize     75
	set CTickCounter  0	
	updateLabel	

	set __Ticker($this,indicator) 0

	set CSes    ""
    }

    method ticking {} {
	after 1000 [code $this ticking]

	incr CTickCounter -1
	if { $CTickCounter < 0 } { set CTickCounter $CTickSize }	
	updateLabel

	if {[info exists CCommandArray($CTickCounter)]} {
	    $CSes toSMM $CCommandArray($CTickCounter)
	}
    }
}
